-- ASCII Reader by chill for Clientside

dcpp:setListener( "pm", "ASCII",
	function(  hub, user, data )
		local nick = user:getNick()
		ASCII:ParseData( hub, nick, data )
	end
)

dcpp:setListener( "timer", "ASCII",
	function()
		ASCII:OnTimer()
	end
)

ASCII = {}

-- The Folder
ASCII._Folder = "scripts/ChillGameServer/Ascii.Server/Asciis/"

-- Max Chars for ASCII's to be sent, all are saved
ASCII._MaxChars = 10000


-------------
ASCII._Config = {

	_Profiles = {

		--["$ALL"] = 1,	-- to allow all to add asciis
		["$OP"] = 1,	-- to allow only Op's to add asciis

	},

}

-------------

-- PTOKAX FUNCS

function ASCII:Main()
	ASCII:GetAsciis()
	ASCII:ShowAscii()
	GameServer:AddServer( "Ascii" )
end

function ASCII:OnTimer()
	table.foreachi(self._Timers, function(_,v)
		v[1] = v[1] + 1
		if (v[1] >= v[2]) then
			v[1] = 0
			v[3]()
		end
	end)
end

function ASCII:ParseData( shub, snick, sdata )

	if self:CheckHub( shub ) then

		local _,_,arg1 = string.find(sdata,"^(%S+)")
		if arg1 then
			arg1 = string.lower(arg1)
			if self._Trigs[arg1] then
				self._Trigs[arg1]( self, shub, snick, sdata )
			end
		end
	end
end

function ASCII:CheckHub( shub )
	if GameServer and GameServer:IsHub(shub, "Ascii") then
		return 1
	end
end
	
function ASCII:SendToUser( shub, snick, data )
	local ownNick = shub:getOwnNick()
	DC():SendHubMessage( shub:getId(), "$To: "..snick.." From: "..ownNick.." $<"..ownNick.."> "..data.."|" )
end

function ASCII:SendToAll( data )
	table.foreach(dcpp:getHubs(), function (_, shub)
		if self:CheckHub( shub ) then
			local ownNick = shub:getOwnNick()
			DC():SendHubMessage( shub:getId(), "<"..ownNick.."> "..data.."|" )
		end
	end)
end


-- SCRIPT FUNCS

function ASCII:SaveAscii(filename,ascii)
	local handle = io.open(self._Folder..filename,"w")
	ascii = string.gsub(ascii,"\r\n","\n")
	handle:write(ascii)
	handle:close()
end

function ASCII:LoadAscii(filename)
	local handle = io.open(self._Folder..filename,"r")
	if handle then
		local ascii = handle:read("*a")
		ascii = string.gsub(ascii,"|",string.char(166))
		handle:close()
		return ascii
	end
end

function ASCII:GetAsciis()

	self.ascii = {}

	os.execute("dir \""..self._Folder.."\" /a-d /b > asciislist.txt")

	local handle = io.open("asciislist.txt","r")
	if handle then
		for line in handle:lines() do
			if ( string.sub(line,string.len(line)-3,string.len(line)) == ".txt") then
				local ascii = self:LoadAscii(line)
				if ascii then
					self:AddAscii(ascii)
				end
			end
		end
		handle:close()
		os.remove("asciislist.txt")
	end
end

function ASCII:AddAscii(ascii)

	self.ascii = self.ascii or {}
	if (string.len(ascii) <= self._MaxChars) then

		table.insert(self.ascii,ascii)
	end
end

function ASCII:ShowAscii()
	self.ascii = self.ascii or {}
	if (table.getn(self.ascii) ~= 0) then
		local rannum = math.random(table.getn(self.ascii))
		local curascii = self.ascii[rannum]
		self:SendToAll("\n"..curascii.."\n")
	end
end
--------------------------------
--------------------------------
function ASCII:Allowed(shub, snick)
	local ownNick = shub:getOwnNick()
	if ownNick == snick then
		return 1
	end
	if self._Config._Profiles[snick] then
		return 1
	elseif self._Config._Profiles["$OP"] and shub:isOp(snick) then
		return 1
	elseif self._Config._Profiles["$ALL"] then
		return 1
	end
end

function ASCII:UserAddAscii(shub, snick, data)
	if self:Allowed(shub, snick) then
		local _,_,ascii = string.find(data,"^%S+%s(.*)$")
		if ascii then
			nascii = string.gsub(ascii,"\r\n","\n")
			self:AddAscii(nascii)
			local sizeb = string.len(nascii)
			local filename = snick.."_"..sizeb.."_"..os.date("%d.%m.%y_%H-%M-%S")..".txt"
			filename = string.gsub(filename,"([%/%\%:%*%<%>%?%|]+)","")
			self:SaveAscii(filename, nascii)
			self:SendToUser( shub, snick, "Added ascii, size : "..sizeb.." b\r\n"..ascii )
		else
			self:SendToUser( shub, snick, "Syntax: addascii <ascii>" )
		end
	end
end

--------------
-- Triggers --
--------------
ASCII._Trigs = {

	addascii = ASCII.UserAddAscii,
}

------------
-- Timers --
------------
ASCII._Timers = {

	-- { 0, 1*60, function() ASCII:ShowAscii() end }  -- Send a Ascii every minute

	{ 0, 10*60, function() ASCII:ShowAscii() end }  -- Send a Ascii every 10 minutes

	-- { 0, 60*60, function() ASCII.GetAsciis() end }  -- Check for new asciis every hour
}


ASCII:Main()

-------------------------------------------------------------------------
DC():PrintDebug( "  ** Loaded ASCII.V.001.lua **" )
-------------------------------------------------------------------------