
-- Draw a Board in sans

function MADN._DrawBoard.SansSerif(sgame)

	-- The Colors    "..s[1][1].."
	local colors = { "  {) ","  {} ","  {) ","  {} " }
	local spacer = "       "

	-- dice
	local dc = sgame._dice

	-- field
	local f = {}

	table.foreachi(sgame._field, function(i,v)
		if v._pos == 0 then
			f[i] = spacer
		else
			f[i] = colors[v._pos]
		end
	end)

	-- make players start and home
	local s = {}
	local h = {}

	for i = 1,4 do
		s[i]={}
		h[i]={}
		for i2 = 1,4 do
			if sgame._starts[i][i2] then
				s[i][i2] = colors[i]
			else
				s[i][i2] = spacer
			end

			if sgame._homes[i][i2] then
				h[i][i2] = colors[i]
			else
				h[i][i2] = spacer
			end
		end
	end

	local board = "  \r\n"..
	"  _____   _____                              _____   _____   _____                               _____   _____  \r\n"..
	"/\\/\\                          /\\/\\/\\                           /\\/\\ \r\n"..
	"  ".. s[1][1].."      ".. s[1][2].."                              ".. f[9].."      ".. f[10].."   <"..f[11]..">                            ".. s[2][1].."    ".. s[2][2].."    \r\n"..
	"\\_      _/\\_      _/                          \\_      _/\\_      _/\\_      _/                           \\_      _/\\_      _/  \r\n"..
	"/      \\/      \\                          /      \\/      \\/      \\                           /      \\/      \\ \r\n"..
	"  ".. s[1][3].."      ".. s[1][4].."                              ".. f[8].."    ".. h[2][1].."    ".. f[12].."                               ".. s[2][3].."    ".. s[2][4].."    \r\n"..
	"\\_____/\\_____/                          \\_      _/\\_      _/\\_      _/                           \\_____/\\_____/  \r\n"..
	"                                                     /      \\/      \\/      \\  \r\n"..
	"                                                       ".. f[7].."    ".. h[2][2].."    ".. f[13].."    \r\n"..
	"                                                     \\_      _/\\_      _/\\_      _/  \r\n"..
	"                                                     /      \\/      \\/      \\  \r\n"..
	"                                                       ".. f[6].."    ".. h[2][3].."    ".. f[14].."    \r\n"..
	"  _____   _____    _____   _____ \\_      _/\\_      _/\\_      _/  _____   _____   _____    ____   \r\n"..
	"/\\/\\/\\/\\/      \\/      \\/      \\/\\/\\/\\/\\  \r\n"..
	" <"..f[1]..">    ".. f[2].."     ".. f[3].."     ".. f[4].."     ".. f[5].."    ".. h[2][4].."    ".. f[15].."     ".. f[16].."     ".. f[17].."     ".. f[18].."     ".. f[19].."     \r\n"..
	"\\_      _/\\_____/\\_____/\\_____/\\_____/\\_____/\\_____/\\_____/\\_____/\\_____/\\_       _/ \r\n"..
	"/      \\/\\/\\/\\/\\'    __    '/\\/\\/\\/\\/       \\  \r\n"..
	"  ".. f[40].."      ".. h[1][1].."     ".. h[1][2].."     ".. h[1][3].."      ".. h[1][4].."     ".. dc.."    ".. h[3][4].."      ".. h[3][3].."     ".. h[3][2].."     ".. h[3][1].."      ".. f[20].."    \r\n"..
	"\\_      _/\\_____/\\_____/\\_____/\\_____/'        '\\_____/\\_____/\\_____/\\_____/\\_       _/ \r\n"..
	"/      \\/\\/\\/\\/\\/\\/\\/\\/\\/\\/       \\   \r\n"..
	"   ".. f[39].."      ".. f[38].."     ".. f[37].."     ".. f[36].."     ".. f[35].."    ".. h[4][4].."    ".. f[25].."     ".. f[24].."     ".. f[23].."     ".. f[22].."   <"..f[21]..">   \r\n"..
	"\\_____/\\_____/\\_____/\\_____/\\_      _/\\_      _/\\_      _/\\_____/\\_____/\\_____/\\_____/  \r\n"..
	"             /      \\/      \\/      \\              \r\n"..
	"                                                        ".. f[34].."    ".. h[4][3].."    ".. f[26].."    \r\n"..
	"                                                      \\_      _/\\_      _/\\_      _/ \r\n"..
	"                                                      /      \\/      \\/      \\  \r\n"..
	"                                                        ".. f[33].."    ".. h[4][2].."    ".. f[27].."    \r\n"..
	"                                                      \\_      _/\\_      _/\\_      _/    \r\n"..
	"/\\/\\                           /      \\/      \\/      \\                          /\\/\\\r\n"..
	"  ".. s[4][1].."     ".. s[4][2].."                               ".. f[32].."    ".. h[4][1].."    ".. f[28].."                               ".. s[3][1].."     ".. s[3][2].."    \r\n"..
	"\\_      _/\\_      _/                           \\_      _/\\_      _/\\_      _/                          \\_      _/\\_      _/\r\n"..
	"/      \\/      \\                           /      \\/      \\/      \\                          /      \\/      \\ \r\n"..
	"  ".. s[4][3].."     ".. s[4][4].."                             <"..f[31]..">   ".. f[30].."      ".. f[29].."                               ".. s[3][3].."     ".. s[3][4].."   \r\n"..
	"\\_____/\\_____/                           \\_____/\\_____/\\_____/                          \\_____/\\_____/ \r\n"

	table.foreachi(sgame._Playnum, function(i,v)
		local nick = v._nick
		if (nick == sgame._toPlay[1]._nick) then
			board = board.."\t\t-> "..nick.."  -  "..colors[i].."\r\n"
		else
			board = board.."\t\t"..nick.."  -  "..colors[i].."\r\n"
		end
	end)

	return board
end
		
